﻿Shader "Mgin/ShaderTest" {
	Properties
	{
		_MainTex ("",2D) = "white" {}
		_Cutoff ("", Float) = 0.5
		_Color ("", Color ) = (1,1,1,1)
	}
	Category
	{
		Fog { Mode Off }
		SubShader
		{
			Tags { "RenderType" = "Opaque" "DepthRender"="Opaque" }
			Pass{
CGPROGRAM
#pragma vertex vert
#pragma fragment frag
#include "UnityCG.cginc"
uniform half4 _MainTex_TexelSize;
/*
struct v2f {
	float4 pos : SV_POSITION;
	float depth : TEXCOORD0;
};

v2f vert (appdata_base v) {
	v2f o;
	o.pos = mul (UNITY_MATRIX_MVP, v.vertex);		
	
	// x is 1.0 (or –1.0 if currently rendering with a flipped projection matrix), 
	// y is the camera’s near plane, z is the camera’s far plane and w is 1/FarPlane.				
	//o.depth = mul(UNITY_MATRIX_MVP, v.vertex).z * _ProjectionParams.w;						
	//o.depth = mul(UNITY_MATRIX_IT_MV, v.vertex).z;		
	
	// 1. 뷰 공간에서 시점이 원점, 원점에서 정점의 거리가 곧 깊이값이 된다.
	//o.depth = length(mul(UNITY_MATRIX_MV, v.vertex))* _ProjectionParams.w;

	// 2. 
	///o.depth = o.pos.w * _ProjectionParams.w;						

	o.depth = mul(UNITY_MATRIX_IT_MV, v.vertex).z* _ProjectionParams.w;

	return o;
}
half4 frag(v2f i) : SV_Target 
{						
	return fixed4(i.depth, i.depth, i.depth, 1);	
}
*/

sampler2D _CameraDepthTexture;

struct v2f {
   float4 pos : SV_POSITION;
   float4 scrPos:TEXCOORD1;
};

// Projected screen position helpers
/* _ScreenParams : x is the current render target width in pixels, 
                   y is the current render target height in pixels, 
				   z is 1.0 + 1.0/width and 
				   w is 1.0 + 1.0/height.
 _ProjectionParams : x is 1.0 (or –1.0 if currently rendering with a flipped projection matrix), 
					 y is the camera’s near plane, 
					 z is the camera’s far plane and 
					 w is 1/FarPlane.
 _MainTex_TexelSize : Vector4(1 / width, 1 / height, width, height)
 */
inline float4 CustomScreenPos (float4 pos) 
{	
	float4 o = pos;
	// x, y, z 값을 w로 나누어 w는 1이되게 하고 xyz는 -1~1의 범위를 갖게 한다. NDC 공간
	o.xy = (o.xy+_MainTex_TexelSize.xy) / o.w;	
	o.xy = float2(o.x+1, o.y+1) * 0.5;	// -1~1 범위를 0~1로 변경	
	return o;
}

// Used to linearize Z buffer values. 
// x is (1-far/near), 
// y is (far/near), 
// z is (x/far) and w is (y/far).
inline float CustomLinear01Depth( float z )
{
	return 1.0 / (_ZBufferParams.x * z + _ZBufferParams.y);	
	//return 1/ (z *(1- _ProjectionParams.z/_ProjectionParams.y) + _ProjectionParams.z/_ProjectionParams.y);
}

v2f vert (appdata_base v){
   v2f o;
   o.pos = mul (UNITY_MATRIX_MVP, v.vertex);
   o.scrPos= ComputeScreenPos(o.pos);   
   //o.scrPos.xy = o.pos.xy * 0.5 + _ScreenParams.zw*0.5;
   return o;
}

//Fragment Shader
half4 frag (v2f i) : COLOR{
   //Grab the depth value from the depth texture
   //Linear01Depth restricts this value to [0, 1]
   float depthValue = CustomLinear01Depth (tex2Dproj(_CameraDepthTexture, UNITY_PROJ_COORD(i.scrPos)).r);

   // UNITY_PROJ_COORD (a) - 4 개의 벡터 구성요소를 전달하면 
   // 투영된 텍스처 읽기에 적절한 텍스처 좌표를 리턴합니다. 
   // 대부분의 플랫폼에서는 전달된 값 자체를 리턴합니다.
   depthValue = CustomLinear01Depth(tex2Dproj(_CameraDepthTexture, i.scrPos)).r;
   half4 depth;

   depth.r = depthValue;
   depth.g = depthValue;
   depth.b = depthValue;

   depth.a = 1;
   return depth;
}


					//http://williamchyr.com/2013/11/unity-shaders-depth-and-normal-textures/
					//http://www.gpgstudy.com/forum/viewtopic.php?t=1337&highlight=
					//http://docs.unity3d.com/kr/current/Manual/SL-CameraDepthTexture.html
					//http://raptusgames.com/youre-such-a-nerd-b-vol03/
					//http://answers.unity3d.com/questions/877170/render-scene-depth-to-a-texture.html
				ENDCG
			}
		}
	}
}
// https://en.wikibooks.org/wiki/Cg_Programming/Unity/Shading_in_World_Space
// https://github.com/robertcupisz/LightShafts/blob/master/Depth.shader
// http://forum.unity3d.com/threads/_projectionparams-z-is-not-equal-to-camera-farclipplane.204592/